﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraLogic : MonoBehaviour
{
    float _ffixedScrollSpeed = 0.05f;

    float _curSpeed = 0;

    public const float C_SECTOR_SIZE_X = 10; //it's actually 8 but doesn't matter if it's larger
    public const float C_SECTOR_SIZE_Y = 6;

    Camera _camera;
    // Start is called before the first frame update
    static CameraLogic _this;

    public static CameraLogic Get() { return _this; }
    public void SetSpeed(float speed)
    {
        _curSpeed = speed;
    }

    private void Awake()
    {
        _this = this;
        _camera = GetComponent<Camera>();

    }
    void Start()
    {


    }

    public Vector3 GetPlayerStartPosition()
    {
        var pos = new Vector3((GetCurSector() * C_SECTOR_SIZE_X) + 0.6f, 0, 0);
        return pos;
    }

    public void InitForNewGame()
    {

        _curSpeed = _ffixedScrollSpeed;
#if DEBUG
        Debug.Log("DEBUG MODE!");
        //CHEAT
        SetSector(0);
      //  SetSector(22);
#else
        SetSector(0);
#endif
    }
    void SetSector(int sector)
    {
        Debug.Log("Cheat: Setting sector to " + sector);
        var pos = transform.position;
        pos.x = 3.9f + (sector * C_SECTOR_SIZE_X);
        transform.position = pos;
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    public int GetCurSector()
    {
        float x = transform.position.x;

        return (int)(x / C_SECTOR_SIZE_X);
    }

    public float GetFixedSpeed()
    {

        if (GameLogic.Get()._gameMode == eGameMode.PLAYING)
        {
            return _curSpeed;
        }

        return 0.0f;
    }

    private void FixedUpdate()
    {

        var pos = transform.position;

        pos.x += GetFixedSpeed();
        transform.position = pos;
    }
}
