﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Tracker : MonoBehaviour
{

    Vector2 _Facing;

    // Start is called before the first frame update
    void Start()
    {

    }

    // Update is called once per frame
    void Update()
    {
        
    }


    private void OnCollisionEnter2D(Collision2D collision)
    {
        var script = collision.gameObject.GetComponent<Node>();

        if (!script) return;

        if (!script.CanBeAParent())
        {
            return; //not connected ones we won't kill I guess
        }

        script.OnSpiked();

        RTAudioManager.Get().Play("squish");
        GetComponent<CircleCollider2D>().enabled = false;
        Destroy(gameObject, 0);

    }


    private void OnTriggerEnter2D(Collider2D collision)
    {
        // Debug.Log("Wall collided with " + collision.gameObject.name);
        if (collision.gameObject.CompareTag("PlayerBullet"))
        {

            RTAudioManager.Get().PlayEx("enemy_death", 1.0f, 1.0f, false, 0.1f);

            Destroy(collision.gameObject);
            Destroy(gameObject);
          
        }
    }


    private void FixedUpdate()
    {
        const float speed = 0.07f;
        const float speedx = 0.02f;

        var pos = transform.position;

        pos.y += RTUtil.SinGamePulseBySeconds(0.5f) * speed;

        pos.x += speedx;

        transform.position = pos;
    }

}
